/*
   Kitsune's Curse
   Copyright (C) 2020-2023 Juan J. Martinez <jjm@usebox.net>

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef __ET_CONFIG_H
#define __ET_CONFIG_H

#define MAX_ENTITIES 10

#define ET_IS_ENEMY(x) (x->type > ET_PLATFORM && x->type < ET_POTION)

// id for non persistent entities
#define ETID_NP 255

// first ET in map
#define ET_FIRST ET_DOOR

enum entity_type
{
    ET_UNUSED = 0,

    // adds extra info to the map, not real ETs
    ET_FILL,
    // links up/down maps
    ET_LINK,

    // affect is_map_blocked
    ET_DOOR,
    ET_PLATFORM,

    // enemies
    ET_SPIRIT,
    ET_FLAME,
    ET_VAMPIRE,
    ET_ONI,
    ET_NINJA,
    ET_SPIDER,
    ET_DEMON,
    ET_CLOUD,

    // bg
    ET_TORCH,

    // statics
    ET_SWITCH,
    ET_GEM,
    ET_KEY,
    ET_POTION,
    ET_GTAIL,

    // not in map
    ET_EXPLO,
    ET_SPLASH,
};

#endif // __ET_CONFIG_H

