/*
   Kitsune's Curse
   Copyright (C) 2020-2023 Juan J. Martinez <jjm@usebox.net>

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef _INT_H

#include <stdint.h>

extern uint8_t int6;
extern uint8_t tick;
extern uint8_t plw_frame;
extern uint8_t wframes;

void wait();
void wait_for(uint8_t t) __z88dk_fastcall;
void wait_int6();
void setup_int(uint8_t frames) __z88dk_fastcall;

// must be 0xabab
#define MAX_CLOCK 0x0e0e

void pause_player();
void resume_player();

void reset_clock();
uint16_t get_clock();

#undef LOCAL

#endif // _INT_H


