/*
   Kitsune's Curse
   Copyright (C) 2020-2023 Juan J. Martinez <jjm@usebox.net>

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef _MAIN_H
#define _MAIN_H

//#define DEBUG
#define VERSION "B5"

#ifndef LOCAL
#define LOCAL extern
#endif

#define KEY_RIGHT 0
#define KEY_LEFT 1
#define KEY_UP 2
#define KEY_DOWN 3
#define KEY_FIRE 4
#define KEY_PAUSE 5
#define KEY_1 8
#define KEY_2 9
#define KEY_3 10
#define KEY_QUIT 11

#define MAX_GEMS 30

void draw_hud();
void draw_hud_bg();

void init_persistence();
void update_persistence(uint8_t id);
uint8_t check_persistence(uint8_t id);
void spawn_entities(const uint8_t *ents);

void screen_black();
void set_colors();

LOCAL uint8_t frame, px, py, opx, opy, spx, spy, smap, sdir, dir;
LOCAL uint8_t moved;

// all these will be zeroed in one go
LOCAL uint8_t jump_flag, player_h, magic, wdelay, paused, was_hit, cool_down, respawn_delay, gameover_delay, keys, gems, gtail;
#define ZERO_ALL 12

LOCAL uint8_t lives, life;

#undef LOCAL

#endif  // _MAIN_H
